%define		pname sim
%define		mversion 2.5
%define		pversion 2.5
%define 	bversion 19
%define		rversion 3
%define		rpmrelease iworx

%define		basedir /usr/local/sim

%define 	debug_package %{nil}

# INSTRUCTIONS!!! <--------------------- READ THEM!!!
#
# You can rebuild  this  package safely using Command 
# Line Overrides. For example, if you want to rebuild
# this package for RedHat just type:
# $ rpm --rebuild --with redhat package.src.rpm
# $ rpm -ba --with redhat package.spec
#
# mdk = GNU/Linux Mandrake
# rht = Linux Red-Hat
# sus = Suse Linux
# fdr = Fedora Linux
# cos = CentOS
# whb = White Box Linux
# rhe = Red Hat Enterprise
# unk = Unknown
#

%define		build_unk      1

##
# THIS MUST BE LAST
##

%if %{build_unk}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype Unknown Distribution
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%endif

############### RPM ################################

Summary:	SIM - System Integrity Monitor
Name:		%{pname}
Version:	%{pversion}
Release: 	%{release}
License:	GPL

Group:		System Environment/Daemons
Source0:	%{name}-current.tar.gz
URL:		http://www.rfxnetworks.com/sim.php

Distribution:	InterWorx-HAL
Vendor:         NEXCESS.NET L.L.C
Packager:	Chris Wells <clwells@nexcess.net>

BuildRoot:	%{_tmppath}/%{name}-%{version}-root

BuildArch:	noarch

Source1:	conf.sim

Requires:	grep
Requires:	sed
Requires:	coreutils

Patch0:		sim-2.5-3-spam-clam.patch
Patch1:         sim-2.5-3-systemd.patch

%description
SIM is a system and services monitor for SysVinit systems. 
It is designed to be intuitive and modular in nature, and 
to provide a clean and informative status system.

%prep

[ -n %{buildroot} ] && rm -rf %{buildroot}

[ -d $RPM_BUILD_DIR/%{name}-%{pversion} ] && rm -rf $RPM_BUILD_DIR/%{name}-%{pversion}

%setup -q -n %{name}-%{version}-%{rversion}

%patch0 -p1
%patch1 -p1

# Try detecting newest gcc (some distributions have got more then one compiler)
# and write it on a temp file 

[ -f %{_tmppath}/%{name}-%{pversion}-gcc ] && rm -f %{_tmppath}/%{name}-%{pversion}-gcc

if   [ -x /usr/bin/gcc-3.2.3 ]; then
	echo "/usr/bin/gcc-3.2.3" > %{_tmppath}/%{name}-%{pversion}-gcc
elif   [ -x /usr/bin/gcc-3.2.2 ]; then
	echo "/usr/bin/gcc-3.2.2" > %{_tmppath}/%{name}-%{pversion}-gcc
elif   [ -x /usr/bin/gcc-3.2.1 ]; then
	echo "/usr/bin/gcc-3.2.1" > %{_tmppath}/%{name}-%{pversion}-gcc
elif [ -x /usr/bin/gcc-3.2 ]; then
        echo "/usr/bin/gcc-3.2" > %{_tmppath}/%{name}-%{pversion}-gcc
elif [ -x /usr/bin/gcc-3.1.1 ]; then
        echo "/usr/bin/gcc-3.1.1" > %{_tmppath}/%{name}-%{pversion}-gcc
else
	echo "gcc" > %{_tmppath}/%{name}-%{pversion}-gcc
fi

# Display compilation flags and OS with colors ;)

[ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] && rm -f %{_tmppath}/%{name}-%{pversion}-show_flags
cat <<EOF >>%{_tmppath}/%{name}-%{pversion}-show_flags
#!/bin/sh

RPM="RPM RELEASE: \033[40m\033[001;033m%{release}"
OS="OS TYPE IS : \033[40m\033[001;033m%{ostype}"
GCC="GCC IS     : \033[40m\033[001;033m`cat %{_tmppath}/%{name}-%{pversion}-gcc`"
CCF="CCFLAGS    : \033[40m\033[001;033m%{ccflags}"
LDF="LDFLAGS    : \033[40m\033[001;033m%{ldflags}"

echo
echo
echo -e "\033[40m\033[001;031m\$RPM\033[0m"
echo -e "\033[40m\033[001;031m\$OS\033[0m"
echo -e "\033[40m\033[001;031m\$GCC\033[0m"
echo -e "\033[40m\033[001;031m\$CCF\033[0m"
echo -e "\033[40m\033[001;031m\$LDF\033[0m"
echo
echo

sleep 3

EOF

# Take care to execute and then to delete
chmod u+x %{_tmppath}/%{name}-%{pversion}-show_flags
%{_tmppath}/%{name}-%{pversion}-show_flags
[ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] && rm -f %{_tmppath}/%{name}-%{pversion}-show_flags

# We have gcc written in a temp file
export CC="`cat %{_tmppath}/%{name}-%{pversion}-gcc`"
export CFLAGS="%{ccflags}"
export LDFLAGS="%{ldflags}"

# Delete gcc temp file
[ -f %{_tmppath}/%{name}-%{pversion}-gcc ] && rm -f %{_tmppath}/%{name}-%{pversion}-gcc

%build

%install

%{__mkdir} -p %{buildroot}%{basedir}

%{__cp} -R install/* %{buildroot}%{basedir}
%{__cp} -f %{SOURCE1} %{buildroot}%{basedir}/conf.sim

%{__mkdir} -p %{buildroot}%{basedir}/doc
%{__cp} CHANGELOG CREDITS GPL README %{buildroot}%{basedir}/doc

echo %{version} > %{buildroot}%{basedir}/version

%clean
[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}
[ -d $RPM_BUILD_DIR/%{name}-%{pversion} ] && rm -rf $RPM_BUILD_DIR/%{name}-%{pversion}

%pre

%postun

if [ "$1" = "0" ]; then
  rm -f %{_prefix}/local/sbin/sim
  rm -f %{_prefix}/local/sbin/sim-autoconf

  rm -f /etc/cron.d/sim 2>/dev/null || :

  /bin/grep -v '* * * * root %{basedir}/sim' /etc/crontab > /etc/crontab.new 2>/dev/null || :
  mv -f /etc/crontab.new /etc/crontab
fi

%post

/bin/ln -fs %{basedir}/sim      %{_prefix}/local/sbin/sim
/bin/ln -fs %{basedir}/autoconf %{_prefix}/local/sbin/sim-autoconf

if ! /bin/grep '* * * * root %{basedir}/sim' /etc/cron.d/sim > /dev/null 2>&1; then
  echo "" >> /etc/cron.d/sim
  echo "*/5 * * * * root %{basedir}/sim -q > /dev/null 2>&1" >> /etc/cron.d/sim
fi

if /bin/grep '* * * * root %{basedir}/sim' /etc/crontab > /dev/null 2>&1; then
  /bin/grep -v '* * * * root %{basedir}/sim' /etc/crontab > /etc/crontab.new 2>/dev/null || :
  mv -f /etc/crontab.new /etc/crontab
fi

/bin/sed -i -r "s/EVLIMIT=\"[0-9]+\"/EVLIMIT=\"0\"/" /usr/local/sim/conf.sim

%preun

%posttrans
/bin/ln -fs %{basedir}/sim      %{_prefix}/local/sbin/sim
/bin/ln -fs %{basedir}/autoconf %{_prefix}/local/sbin/sim-autoconf

%files
%defattr(-,root,root)
%attr(0750,root,root) %dir %{basedir}
%attr(0640,root,root) %{basedir}/internals/*
%attr(0750,root,root) %{basedir}/sim
%attr(0750,root,root) %{basedir}/autoconf
%config(noreplace) %attr(0640,root,root) %{basedir}/conf.sim
%attr(0640,root,root) %{basedir}/version

%doc
%attr(0644,root,root) %{basedir}/doc/CHANGELOG
%attr(0644,root,root) %{basedir}/doc/CREDITS
%attr(0644,root,root) %{basedir}/doc/GPL
%attr(0644,root,root) %{basedir}/doc/README

%changelog
* Wed Jul 13 2016 Paul Oehler <poehler@interworx.com>
- Added sim-2.5-3-systemd.patch, which adds support for systemd and el7+
* Thu Jan 17 2013 Matt Parmelee <mparmelee@interworx.com>
- Suppressed errors to ease transition to new cron directory.
* Wed Jan 09 2013 Matt Parmelee <mparmelee@interworx.com>
- Changed cron directory.
* Sat Oct 23 2004 Chris Wells <clwells@nexcess.net>
- initial release
